int wtrLvlH = 12;// pins for LEDs  that show whether the water level is high or low
int wtrLvlL = 13;
bool lvl = false;// booleans used for activating the buzzer
bool flw = true;
int buzzer = 3 ; // buzzer pin
int waterHeight; // water height
int wtrFlwH = 8;// pins for LEDs  that show whether the water flow is high or low
int wtrFlwL = 7 ;
int flowPin = 2;// waterflow sensor pin
double flowRate; // holds the flow rate
volatile int count; // integer that stores the number of impulses
void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  pinMode (wtrLvlH, OUTPUT);// The next four are for setting up the pins for the LEDs
  pinMode (wtrLvlL, OUTPUT);
  pinMode(wtrFlwH, OUTPUT);
  pinMode(wtrFlwL, OUTPUT);
  pinMode (flowPin, INPUT); // receives data from the water flow sensor
  pinMode(buzzer, OUTPUT); // sets up the pin for the buzzer
  attachInterrupt(0, flow, RISING); // setting up an interupt which executes the flow method
}

void loop() {
  // put your main code here, to run repeatedly:
  count = 0;
  interrupts(); // in the next three lines the loop is interrupted, then we count the number of pulses for one second and finally we resume with the program
  delay(1000);
  noInterrupts();
  flowRate = (count * 2.25); // The next three lines convert the pulses to L/s
  flowRate = flowRate * 60;
  flowRate = flowRate / 1000;

  waterHeight = analogRead(A0); // gives a reading of the water height sensor
  if (waterHeight >= 385) {
    digitalWrite(wtrLvlH , HIGH);
    digitalWrite(wtrLvlL, LOW);
    lvl = true; // if the water height is high then we turn on the LED that shows it and we set the boolean for the height to true since thats the first sign of a clog
    if (flowRate >= 1.6) {
      digitalWrite(wtrFlwH, HIGH);
      digitalWrite(wtrFlwL, LOW) ;
      flw = false;  // if the water flow is high we turn on the LED for it and we set the boolean for the flow to false because it is not a sign of a clog

    }
    else {
      digitalWrite(wtrFlwL, HIGH);
      digitalWrite(wtrFlwH, LOW) ;
      flw = true; // if the water flow is low we turn on the LED for it and we set the boolean for the flow to true because it is  a sign of a clog


    }

  }
  else {
    digitalWrite(wtrLvlL, HIGH);
    digitalWrite(wtrLvlH, LOW);
    lvl = false; //if the water height is low then we turn on the LED that shows it and we set the boolean for the height to false since thats not a  sign of a clog
    if (flowRate >= 1.6) {
      digitalWrite(wtrFlwH, HIGH);
      digitalWrite(wtrFlwL, LOW) ;
      flw = false; // if the flowrate is high then the LED for it is on and we set the boolean for the flow to false because it is not a sign of a clog 
    }
    else {
      digitalWrite(wtrFlwL, HIGH);
      digitalWrite(wtrFlwH, LOW) ;
       // if the flow rate is low we turn on the LED for it 
    }
  }
  if (lvl && flw) {
    tone(buzzer, 1000);
  // if both of the conditions are true we receive a signal from the buzzer that there is a clog
  }
  else if(lvl == false && flw == false) {
    tone(buzzer,2000); // if we have a low water level and a high water flow then that might mean that there is an issue with one of the sensors so we receive a different signal from the buzzer
  }
  else {
    noTone(buzzer); // the buzzer is off if there is nothing wrong
  }



  Serial.print(waterHeight);
  Serial.print(",");
  Serial.println(flowRate);
  delay(100);
}
void flow() {
  count++ ;
}
// method for counting the impulses
